package net.sf.sido;

import java.util.Collection;
import java.util.List;

import net.sf.sido.array.Array;

import com.google.common.base.Predicate;

public interface DataType {

	/**
	 * Type is fully defined and no property can be added any longer (but for extensions)
	 */
	void close();

	<T> DataType extend(String name, Class<T> type, boolean nullable, Predicate<T> constraint);

	DataType extend(String name, DataType type, boolean nullable, boolean reverse, Predicate<DataObject> constraint);

	<T> DataType extendArray(String name, Class<T> type, boolean nullable, Predicate<Array<T>> constraint);

	DataType extendArray(String name, DataType type, boolean nullable, Predicate<Array<DataObject>> constraint);

	String getName();

    String getQualifiedName();

	DataType getParentType();

	Collection<Property<?>> getProperties();

	<T> Property<T> getProperty(String name);

	DataSchema getSchema();

	List<DataType> getSubTypes();

	boolean isAbstractType();

	boolean isExtensible();

	boolean isSubClass(DataType type);

	DataObject newInstance();

	int newInstanceId();

	DataObject newInstance(boolean init);

	DataObject newInstance(boolean init, boolean deep);

}
