package net.sf.sido.constraint;

import java.math.BigDecimal;

import com.google.common.base.Predicate;

public class GTConstraint<N extends Number> implements Predicate<N> {

	private final BigDecimal min;

	public GTConstraint(BigDecimal min) {
		this.min = min;
	}

	@Override
	public boolean apply(N n) {
		return new BigDecimal(n.toString()).compareTo(this.min) > 0;
	}

}
