package net.sf.sido.factory.support;

import com.google.common.base.Predicate;
import net.sf.sido.DataFactory;
import net.sf.sido.DataObject;
import net.sf.sido.array.Array;
import net.sf.sido.constraint.ConstraintDefinitions;

public abstract class AbstractPropertyAssembler implements PropertyAssembler {

	protected final String name;


    public AbstractPropertyAssembler(String name) {
		this.name = name;
	}

	protected boolean isNullable(DataObject property) {
        return property.getBoolean(SiDOSchema.NULLABLE);
	}

	protected <T> Predicate<T> readConstraint(DataFactory factory, DataObject property) {
        final Array<DataObject> constraints = property.getDOArray(SiDOSchema.CONSTRAINTS);
        if (constraints != null && !constraints.isEmpty()) {
            ConstraintDefinitions constraintDefinitions = new DefaultConstraintDefinitions(constraints);
            return factory.getConstraintFactory().createConstraint(constraintDefinitions);
        } else {
            return null;
        }
	}

}
