package net.sf.sido.factory.support;

import com.google.common.base.Predicate;
import net.sf.sido.DataFactory;
import net.sf.sido.DataObject;
import net.sf.sido.DataSchema;

import java.io.IOException;
import java.util.Map;

public class AnonymousPropertyAssembler extends AbstractPropertyAssembler {

	public AnonymousPropertyAssembler(String name) {
		super(name);
	}

    @Override
    public <T> void addProperty(DataFactory factory, PropertyAssemblerCallback callback, Map<String, DataSchema> schemas, Map<String, TypeDefinition> typeDefinitions, TypeDefinition definition, DataObject property) throws IOException {
		// Property information
		boolean nullable = isNullable(property);
		boolean reverse = property.getBoolean(SiDOSchema.REVERSE);
		// Constraint
		Predicate<DataObject> constraint = readConstraint(factory, property);
		// Adds the property
		definition.getBuilder().addAnonymousProperty(name, reverse, nullable, constraint);
	}

}
